﻿namespace PersonStructColorClass {

	struct Person {
		public string FirstName;
		public string LastName;

		public void TakeLastNameOf(Person partner) {
			LastName = partner.LastName;
		}
	}

	class PersonDatabase {
		private List<Person> persons = new List<Person>();

		public void Add(Person person) {
			persons.Add(person);
		}

		public Person Get(int id) {
			return persons[id];
		}

		public void PrintAll() {
			Console.WriteLine("PersonDatabase contains following people:");
			foreach (Person person in persons) {
				Console.WriteLine("> " + person.FirstName + " " + person.LastName);
			}
		}
	}

	class Program {
		static void Main(string[] args) {
			PersonDatabase database = new PersonDatabase();
			database.Add(new Person { FirstName = "Johnny", LastName = "Winter" });
			database.Add(new Person { FirstName = "Summer", LastName = "Glau" });
			database.PrintAll();

			Person groom = database.Get(0);
			Person bride = database.Get(1);
			bride.TakeLastNameOf(groom);

			Console.WriteLine("Bride after marriage: " + bride.FirstName + " " + bride.LastName);

			database.PrintAll();

			Console.WriteLine();

			//

			Color red = new Color { R = 255, G = 0, B = 0 };
			Label l1 = new Label { Text = "New message", Color = red };
			Label l2 = new Label { Text = "Old message", Color = red };

			for (int i = 0; i < 5; i++) {
				Console.WriteLine("---");
				l1.Show();
				l2.Show();

				l2.FadeOutStep();
			}
		}
	}

	class Color {
		public byte R;
		public byte G;
		public byte B;
	}

	class Label {
		public string Text;
		public Color Color;

		public void FadeOutStep() {
			Color.R = ChannelFadeOutStep(Color.R);
			Color.G = ChannelFadeOutStep(Color.G);
			Color.B = ChannelFadeOutStep(Color.B);
		}

		private static byte ChannelFadeOutStep(byte channelValue) {
			return (byte) (channelValue * 0.25);
		}

		public void Show() {
			Console.WriteLine($"Label: {Text} with {Color.R}/{Color.G}/{Color.B} color");
		}
	}
}