﻿namespace PersonConstruction {

	record Person {
		public string FirstName { get; set; }
		public string? MiddleName { get; set; }
		public string LastName { get; set; }

		public Person(string firstName, string lastName) {
			FirstName = firstName;
			LastName = lastName;
		}
	}

	class X {
		public int x;
		public int y;
		public int z;

		public X() {
			Console.WriteLine("X constructor");
		}
	}

	class Program {
		static void Main(string[] args) {
			var p1 = new Person("Jan", "Kofron");

			var p2 = new Person("Pavel", "Jezek") { MiddleName = "Sonic" };
			
			var p3 = new Person("Pavel", "Jezek");
			p3.MiddleName = "Sonic";

			Console.WriteLine(p1);
			Console.WriteLine(p2);
			Console.WriteLine(p3);

			var p4 = new Person("Pavel", "Jezek") { FirstName = "John", MiddleName = "Sonic", LastName = "Doe" };
            Console.WriteLine(p4);

            //

            var x1 = new X() { x = 1 };
			var x2 = new X { y = 1 };
			var x3 = new X { x = 1, y = 1 };

			//

			// Error: There is no argument given that corresponds to the required parameter 'firstName' of 'Person.Person(string, string)'
			// var p5 = new Person { FirstName = "John", MiddleName = "Sonic", LastName = "Doe" };
		}
	}
}