﻿namespace RequiredMemberInPersonConstruction {

	record Person {
		public required string FirstName { get; set; }
		public string? MiddleName { get; set; }
		public required string LastName { get; set; }
	}

	class Program {
		static void Main(string[] args) {
			var p1 = new Person { FirstName = "Jan", LastName = "Kofron" };
			var p2 = new Person { FirstName = "Pavel", LastName = "Jezek", MiddleName = "Sonic" };

			// C# 11 required:
			// Error: Required member 'Person.LastName' must be set in the object initializer or attribute constructor.
			// var p3 = new Person { FirstName = "Madonna" };

			Console.WriteLine(p1);
			Console.WriteLine(p2);
			// Console.WriteLine(p3);
		}
	}
}