﻿using System;

namespace RecordSimplePrimaryConstructor {

	record class C(int X);				// Immutable

	record struct S(int Y);				// Mutable

	readonly record struct R(int Z);	// Immutable

	class Program {
		static void Main(string[] args) {
			C c1 = new C(10);
			// Error: Init - only property or indexer 'C.X' can only be assigned in an object initializer, or on 'this' or 'base' in an instance constructor or an 'init' accessor.
			// c1.X = 10;
			S s1 = new S();
			s1.Y = 100;
			Console.WriteLine("Main: c1.x == {0}, s1.y == {1}", c1.X, s1.Y);
			f(c1, s1);
			Console.WriteLine("Main: c1.x == {0}, s1.y == {1}", c1.X, s1.Y);

			Console.WriteLine();
			Console.WriteLine(c1);
			Console.WriteLine(s1);

			R r1 = new R();
			// Error: Init - only property or indexer 'R.Z' can only be assigned in an object initializer, or on 'this' or 'base' in an instance constructor or an 'init' accessor.
			// r1.Z = 100;

			Console.WriteLine();
			Console.WriteLine("Main: r1.z == {0}", r1.Z);
			Console.WriteLine(r1);

			R r2 = new R(10);
			Console.WriteLine($"r1: {r1}");
			Console.WriteLine($"r2: {r2}");
			Console.WriteLine();

			r1 = r2;
			Console.WriteLine($"r1: {r1}");
			Console.WriteLine($"r2: {r2}");
		}

		static void f(C c2, S s2) {
			Console.WriteLine(" f:   c2.x == {0}, s2.y == {1}", c2.X, s2.Y);
			// Error: Init - only property or indexer 'C.X' can only be assigned in an object initializer, or on 'this' or 'base' in an instance constructor or an 'init' accessor.
			// c2.X = 20;
			s2.Y = 200;
			Console.WriteLine(" f:   c2.x == {0}, s2.y == {1}", c2.X, s2.Y);
			g(c2, s2);
			Console.WriteLine(" f:   c2.x == {0}, s2.y == {1}", c2.X, s2.Y);
		}

		static void g(C c3, S s3) {
			Console.WriteLine("  g:  c3.x == {0}, s3.y == {1}", c3.X, s3.Y);
			// Error: Init - only property or indexer 'C.X' can only be assigned in an object initializer, or on 'this' or 'base' in an instance constructor or an 'init' accessor.
			// c3.X = 30;
			s3.Y = 300;
			Console.WriteLine("  g:  c3.x == {0}, s3.y == {1}", c3.X, s3.Y);
		}
	}
}
